package quest

import (
	"fmt"
	"witness/conf"

	log "github.com/sirupsen/logrus"
	"gorm.io/driver/postgres"
	"gorm.io/gorm"
)

type Quest struct {
	db *gorm.DB
}

func NewQuest(cfg *conf.QuestConfig) (q *Quest) {
	dsn := fmt.Sprintf("host=%s port=%d user=%s dbname=%s password=%s sslmode=disable", cfg.Host, cfg.Port, cfg.User, cfg.Database, cfg.Password)
	_db, err := gorm.Open(postgres.Open(dsn))
	if err != nil {
		panic(err)
	}
	testSQL := "SELECT 1;"
	err = _db.Raw(testSQL).Error
	if err != nil {
		panic(err)
	}
	log.Info("connect quest success")
	return &Quest{db: _db}
}

func (q *Quest) GetProofs(startTimestamp, endTimestamp int64, lastTaskID string, limit int) (proofs []*ProofModel, err error) {
	querySQL := "SELECT " +
		"`TaskType`, `TaskId`, `TaskFinishTimestamp`, `TaskWorkload`, `TaskReqHash`, `TaskRespHash`, `TaskManagerSignature`, `TaskContainerSignature`, `TaskMinerSignature`, `TaskProfitAccount`, `TaskWorkerAccount` " +
		"FROM `proof` " +
		"WHERE `TaskFinishTimestamp` >= ? AND `TaskFinishTimestamp` < ? " +
		"AND `TaskId` > ? " +
		"ORDER BY `TaskId` ASC " +
		"LIMIT ?;"

	err = q.db.Debug().Raw(querySQL, startTimestamp, endTimestamp, lastTaskID, limit).Scan(&proofs).Error
	return
}
